Loading...
Searching...
No Matches
gerfs: Refine solution - no pivoting
Dense LA » Linear system solvers » General matrices: LU » No pivoting variant

## Functions

magma_int_t | magma_cgerfs_nopiv_gpu (magma_trans_t trans, magma_int_t n, magma_int_t nrhs, magmaFloatComplex_ptr dA, magma_int_t ldda, magmaFloatComplex_ptr dB, magma_int_t lddb, magmaFloatComplex_ptr dX, magma_int_t lddx, magmaFloatComplex_ptr dworkd, magmaFloatComplex_ptr dAF, magma_int_t *iter, magma_int_t *info)
| CGERFS improves the computed solution to a system of linear equations.
magma_int_t | magma_dgerfs_nopiv_gpu (magma_trans_t trans, magma_int_t n, magma_int_t nrhs, magmaDouble_ptr dA, magma_int_t ldda, magmaDouble_ptr dB, magma_int_t lddb, magmaDouble_ptr dX, magma_int_t lddx, magmaDouble_ptr dworkd, magmaDouble_ptr dAF, magma_int_t *iter, magma_int_t *info)
| DGERFS improves the computed solution to a system of linear equations.
magma_int_t | magma_sgerfs_nopiv_gpu (magma_trans_t trans, magma_int_t n, magma_int_t nrhs, magmaFloat_ptr dA, magma_int_t ldda, magmaFloat_ptr dB, magma_int_t lddb, magmaFloat_ptr dX, magma_int_t lddx, magmaFloat_ptr dworkd, magmaFloat_ptr dAF, magma_int_t *iter, magma_int_t *info)
| SGERFS improves the computed solution to a system of linear equations.
magma_int_t | magma_zgerfs_nopiv_gpu (magma_trans_t trans, magma_int_t n, magma_int_t nrhs, magmaDoubleComplex_ptr dA, magma_int_t ldda, magmaDoubleComplex_ptr dB, magma_int_t lddb, magmaDoubleComplex_ptr dX, magma_int_t lddx, magmaDoubleComplex_ptr dworkd, magmaDoubleComplex_ptr dAF, magma_int_t *iter, magma_int_t *info)
| ZGERFS improves the computed solution to a system of linear equations.

## Detailed Description

## Function Documentation

## magma_cgerfs_nopiv_gpu()

magma_int_t magma_cgerfs_nopiv_gpu | ( | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | nrhs,
|  | magmaFloatComplex_ptr | dA,
|  | magma_int_t | ldda,
|  | magmaFloatComplex_ptr | dB,
|  | magma_int_t | lddb,
|  | magmaFloatComplex_ptr | dX,
|  | magma_int_t | lddx,
|  | magmaFloatComplex_ptr | dworkd,
|  | magmaFloatComplex_ptr | dAF,
|  | magma_int_t * | iter,
|  | magma_int_t * | info )

CGERFS improves the computed solution to a system of linear equations.

The iterative refinement process is stopped if ITER > ITERMAX or for all the RHS we have: RNRM < SQRT(n)*XNRM*ANRM*EPS*BWDMAX where o ITER is the number of the current iteration in the iterative refinement process o RNRM is the infinity-norm of the residual o XNRM is the infinity-norm of the solution o ANRM is the infinity-operator-norm of the matrix A o EPS is the machine epsilon returned by SLAMCH('Epsilon') The value ITERMAX and BWDMAX are fixed to 30 and 1.0D+00 respectively.

Parameters

  [in]

  trans

  magma_trans_t Specifies the form of the system of equations:
  - = MagmaNoTrans: A * X = B (No transpose)
  - = MagmaTrans: A**T * X = B (Transpose)
  - = MagmaConjTrans: A**H * X = B (Conjugate transpose)

  [in] | n | INTEGER The number of linear equations, i.e., the order of the matrix A. N >= 0.
  [in] | nrhs | INTEGER The number of right hand sides, i.e., the number of columns of the matrix B. NRHS >= 0.
  [in] | dA | COMPLEX array on the GPU, dimension (ldda,N) the N-by-N coefficient matrix A.
  [in] | ldda | INTEGER The leading dimension of the array dA. ldda >= max(1,N).
  [in] | dB | COMPLEX array on the GPU, dimension (lddb,NRHS) The N-by-NRHS right hand side matrix B.
  [in] | lddb | INTEGER The leading dimension of the array dB. lddb >= max(1,N).
  [in,out] | dX | COMPLEX array on the GPU, dimension (lddx,NRHS) On entry, the solution matrix X, as computed by CGETRS_NOPIV. On exit, the improved solution matrix X.
  [in] | lddx | INTEGER The leading dimension of the array dX. lddx >= max(1,N).
  | dworkd | (workspace) COMPLEX array on the GPU, dimension (N*NRHS) This array is used to hold the residual vectors.
  | dAF | COMPLEX array on the GPU, dimension (ldda,n) The factors L and U from the factorization A = L*U as computed by CGETRF_NOPIV.

  [out]

  iter

  INTEGER
  - < 0: iterative refinement has failed, real factorization has been performed
    - -1 : the routine fell back to full precision for implementation- or machine-specific reasons
    - -2 : narrowing the precision induced an overflow, the routine fell back to full precision
    - -3 : failure of SGETRF
    - -31: stop the iterative refinement after the 30th iteration
  - > 0: iterative refinement has been successfully used. Returns the number of iterations

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if info = -i, the i-th argument had an illegal value
  - > 0: if info = i, U(i,i) computed in REAL is exactly zero. The factorization has been completed, but the factor U is exactly singular, so the solution could not be computed.

## magma_dgerfs_nopiv_gpu()

magma_int_t magma_dgerfs_nopiv_gpu | ( | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | nrhs,
|  | magmaDouble_ptr | dA,
|  | magma_int_t | ldda,
|  | magmaDouble_ptr | dB,
|  | magma_int_t | lddb,
|  | magmaDouble_ptr | dX,
|  | magma_int_t | lddx,
|  | magmaDouble_ptr | dworkd,
|  | magmaDouble_ptr | dAF,
|  | magma_int_t * | iter,
|  | magma_int_t * | info )

DGERFS improves the computed solution to a system of linear equations.

The iterative refinement process is stopped if ITER > ITERMAX or for all the RHS we have: RNRM < SQRT(n)*XNRM*ANRM*EPS*BWDMAX where o ITER is the number of the current iteration in the iterative refinement process o RNRM is the infinity-norm of the residual o XNRM is the infinity-norm of the solution o ANRM is the infinity-operator-norm of the matrix A o EPS is the machine epsilon returned by DLAMCH('Epsilon') The value ITERMAX and BWDMAX are fixed to 30 and 1.0D+00 respectively.

Parameters

  [in]

  trans

  magma_trans_t Specifies the form of the system of equations:
  - = MagmaNoTrans: A * X = B (No transpose)
  - = MagmaTrans: A**T * X = B (Transpose)
  - = MagmaConjTrans: A**H * X = B (Conjugate transpose)

  [in] | n | INTEGER The number of linear equations, i.e., the order of the matrix A. N >= 0.
  [in] | nrhs | INTEGER The number of right hand sides, i.e., the number of columns of the matrix B. NRHS >= 0.
  [in] | dA | DOUBLE PRECISION array on the GPU, dimension (ldda,N) the N-by-N coefficient matrix A.
  [in] | ldda | INTEGER The leading dimension of the array dA. ldda >= max(1,N).
  [in] | dB | DOUBLE PRECISION array on the GPU, dimension (lddb,NRHS) The N-by-NRHS right hand side matrix B.
  [in] | lddb | INTEGER The leading dimension of the array dB. lddb >= max(1,N).
  [in,out] | dX | DOUBLE PRECISION array on the GPU, dimension (lddx,NRHS) On entry, the solution matrix X, as computed by DGETRS_NOPIV. On exit, the improved solution matrix X.
  [in] | lddx | INTEGER The leading dimension of the array dX. lddx >= max(1,N).
  | dworkd | (workspace) DOUBLE PRECISION array on the GPU, dimension (N*NRHS) This array is used to hold the residual vectors.
  | dAF | DOUBLE PRECISION array on the GPU, dimension (ldda,n) The factors L and U from the factorization A = L*U as computed by DGETRF_NOPIV.

  [out]

  iter

  INTEGER
  - < 0: iterative refinement has failed, double precision factorization has been performed
    - -1 : the routine fell back to full precision for implementation- or machine-specific reasons
    - -2 : narrowing the precision induced an overflow, the routine fell back to full precision
    - -3 : failure of SGETRF
    - -31: stop the iterative refinement after the 30th iteration
  - > 0: iterative refinement has been successfully used. Returns the number of iterations

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if info = -i, the i-th argument had an illegal value
  - > 0: if info = i, U(i,i) computed in DOUBLE PRECISION is exactly zero. The factorization has been completed, but the factor U is exactly singular, so the solution could not be computed.

## magma_sgerfs_nopiv_gpu()

magma_int_t magma_sgerfs_nopiv_gpu | ( | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | nrhs,
|  | magmaFloat_ptr | dA,
|  | magma_int_t | ldda,
|  | magmaFloat_ptr | dB,
|  | magma_int_t | lddb,
|  | magmaFloat_ptr | dX,
|  | magma_int_t | lddx,
|  | magmaFloat_ptr | dworkd,
|  | magmaFloat_ptr | dAF,
|  | magma_int_t * | iter,
|  | magma_int_t * | info )

SGERFS improves the computed solution to a system of linear equations.

The iterative refinement process is stopped if ITER > ITERMAX or for all the RHS we have: RNRM < SQRT(n)*XNRM*ANRM*EPS*BWDMAX where o ITER is the number of the current iteration in the iterative refinement process o RNRM is the infinity-norm of the residual o XNRM is the infinity-norm of the solution o ANRM is the infinity-operator-norm of the matrix A o EPS is the machine epsilon returned by SLAMCH('Epsilon') The value ITERMAX and BWDMAX are fixed to 30 and 1.0D+00 respectively.

Parameters

  [in]

  trans

  magma_trans_t Specifies the form of the system of equations:
  - = MagmaNoTrans: A * X = B (No transpose)
  - = MagmaTrans: A**T * X = B (Transpose)
  - = MagmaConjTrans: A**H * X = B (Conjugate transpose)

  [in] | n | INTEGER The number of linear equations, i.e., the order of the matrix A. N >= 0.
  [in] | nrhs | INTEGER The number of right hand sides, i.e., the number of columns of the matrix B. NRHS >= 0.
  [in] | dA | REAL array on the GPU, dimension (ldda,N) the N-by-N coefficient matrix A.
  [in] | ldda | INTEGER The leading dimension of the array dA. ldda >= max(1,N).
  [in] | dB | REAL array on the GPU, dimension (lddb,NRHS) The N-by-NRHS right hand side matrix B.
  [in] | lddb | INTEGER The leading dimension of the array dB. lddb >= max(1,N).
  [in,out] | dX | REAL array on the GPU, dimension (lddx,NRHS) On entry, the solution matrix X, as computed by SGETRS_NOPIV. On exit, the improved solution matrix X.
  [in] | lddx | INTEGER The leading dimension of the array dX. lddx >= max(1,N).
  | dworkd | (workspace) REAL array on the GPU, dimension (N*NRHS) This array is used to hold the residual vectors.
  | dAF | REAL array on the GPU, dimension (ldda,n) The factors L and U from the factorization A = L*U as computed by SGETRF_NOPIV.

  [out]

  iter

  INTEGER
  - < 0: iterative refinement has failed, real factorization has been performed
    - -1 : the routine fell back to full precision for implementation- or machine-specific reasons
    - -2 : narrowing the precision induced an overflow, the routine fell back to full precision
    - -3 : failure of SGETRF
    - -31: stop the iterative refinement after the 30th iteration
  - > 0: iterative refinement has been successfully used. Returns the number of iterations

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if info = -i, the i-th argument had an illegal value
  - > 0: if info = i, U(i,i) computed in REAL is exactly zero. The factorization has been completed, but the factor U is exactly singular, so the solution could not be computed.

## magma_zgerfs_nopiv_gpu()

magma_int_t magma_zgerfs_nopiv_gpu | ( | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | nrhs,
|  | magmaDoubleComplex_ptr | dA,
|  | magma_int_t | ldda,
|  | magmaDoubleComplex_ptr | dB,
|  | magma_int_t | lddb,
|  | magmaDoubleComplex_ptr | dX,
|  | magma_int_t | lddx,
|  | magmaDoubleComplex_ptr | dworkd,
|  | magmaDoubleComplex_ptr | dAF,
|  | magma_int_t * | iter,
|  | magma_int_t * | info )

ZGERFS improves the computed solution to a system of linear equations.

The iterative refinement process is stopped if ITER > ITERMAX or for all the RHS we have: RNRM < SQRT(n)*XNRM*ANRM*EPS*BWDMAX where o ITER is the number of the current iteration in the iterative refinement process o RNRM is the infinity-norm of the residual o XNRM is the infinity-norm of the solution o ANRM is the infinity-operator-norm of the matrix A o EPS is the machine epsilon returned by DLAMCH('Epsilon') The value ITERMAX and BWDMAX are fixed to 30 and 1.0D+00 respectively.

Parameters

  [in]

  trans

  magma_trans_t Specifies the form of the system of equations:
  - = MagmaNoTrans: A * X = B (No transpose)
  - = MagmaTrans: A**T * X = B (Transpose)
  - = MagmaConjTrans: A**H * X = B (Conjugate transpose)

  [in] | n | INTEGER The number of linear equations, i.e., the order of the matrix A. N >= 0.
  [in] | nrhs | INTEGER The number of right hand sides, i.e., the number of columns of the matrix B. NRHS >= 0.
  [in] | dA | COMPLEX_16 array on the GPU, dimension (ldda,N) the N-by-N coefficient matrix A.
  [in] | ldda | INTEGER The leading dimension of the array dA. ldda >= max(1,N).
  [in] | dB | COMPLEX_16 array on the GPU, dimension (lddb,NRHS) The N-by-NRHS right hand side matrix B.
  [in] | lddb | INTEGER The leading dimension of the array dB. lddb >= max(1,N).
  [in,out] | dX | COMPLEX_16 array on the GPU, dimension (lddx,NRHS) On entry, the solution matrix X, as computed by ZGETRS_NOPIV. On exit, the improved solution matrix X.
  [in] | lddx | INTEGER The leading dimension of the array dX. lddx >= max(1,N).
  | dworkd | (workspace) COMPLEX_16 array on the GPU, dimension (N*NRHS) This array is used to hold the residual vectors.
  | dAF | COMPLEX*16 array on the GPU, dimension (ldda,n) The factors L and U from the factorization A = L*U as computed by ZGETRF_NOPIV.

  [out]

  iter

  INTEGER
  - < 0: iterative refinement has failed, double precision factorization has been performed
    - -1 : the routine fell back to full precision for implementation- or machine-specific reasons
    - -2 : narrowing the precision induced an overflow, the routine fell back to full precision
    - -3 : failure of SGETRF
    - -31: stop the iterative refinement after the 30th iteration
  - > 0: iterative refinement has been successfully used. Returns the number of iterations

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if info = -i, the i-th argument had an illegal value
  - > 0: if info = i, U(i,i) computed in DOUBLE PRECISION is exactly zero. The factorization has been completed, but the factor U is exactly singular, so the solution could not be computed.